public class DaunyNativeFunctions {

	private native int IsWindowsNT();
	private native int StartDaunyService();
	private native int StopDaunyService();
	private native int StartDauny(String sFileName);
	private native int StopDauny(String sPathToDauny);
	private native String EncryptPasswort(String sUncryptPassword,String sKey);
	private native String DllVersion();
	
	private native int LoadTrayIcon(String sIconFileName,int nIndex, String sToolTip);
	private native int LoadTrayIcons(String sDllORIconName,int nFileIndex,int nIndex ,int nIconCount);
	private native int SetTrayIconToolTip(int nIndex, String sToolTip);
	private native int ShowTrayIcon(int nIndex);
	private native int RemoveTrayIcon();
	private native int DestoryTrayIconThread();
	
	private native int GoOnline();
	private native int GoOffline();
	private native int IsOnline();
	private native int ShutdownSystem();

	// this method should call from the native code
	public void MouseCallback(int nType) {
		System.err.println(" Mouse callback: "+nType);
	}
	
	static {
		System.loadLibrary("daunytools");
	}
	
	public static void main(String[] args) {
		
		DaunyNativeFunctions app = new DaunyNativeFunctions();
		
		int nError;
		String sMsg;
		String sFileName;
		String sPathToDauny;
		String sUncryptPassword,sKey,sEncryptPassword;
		String sValue;
		
		System.err.print("Check dll version  ...");
		sValue=app.DllVersion();
		if (sValue!=null)
			sMsg= "OK\n Dll version: " + sValue;
		else
			sMsg= "FAILED, error ";		
		System.err.println(sMsg);					
	
		System.err.print("Check WinNT ...");
		if (app.IsWindowsNT()>0)
			sMsg= "OK";
			
		else
			sMsg= "NOT FOUND";
		System.err.println(sMsg);
		

		System.err.print("Load icon 1 ...");
		nError=app.LoadTrayIcon("dauny1.ico",0,"Dauny 1 Icon");
		if (nError==1)
			sMsg= "OK";
		else
			sMsg= "FAILED, error ";
		System.err.println(sMsg);		

		System.err.print("Load icon 2 ...");
		nError=app.LoadTrayIcon("dauny2.ico",1,"Dauny 2 Icon");
		if (nError==1)
			sMsg= "OK";
		else
			sMsg= "FAILED, error ";
		System.err.println(sMsg);			


		System.err.print("Show icon ...");
		nError=app.ShowTrayIcon(0);
		if (nError==1)
			sMsg= "OK";
		else
			sMsg= "FAILED, error ";
		System.err.println(sMsg);		
	
		System.err.print("Start dauny service ...");
		nError=app.StartDaunyService();
		if (nError==0)
			sMsg= "OK";
		else
			sMsg= "FAILED, error " + nError;
		System.err.println(sMsg);
		
		try {
			Thread.currentThread().sleep(3000);
		} catch (InterruptedException e) {
		}
		app.ShowTrayIcon(1);
	
	
		System.err.print("Stop dauny service ...");
		nError=app.StopDaunyService();
		if (nError==0)
			sMsg= "OK";
		else
			sMsg= "FAILED, error " + nError;		
		System.err.println(sMsg);

		try {
			Thread.currentThread().sleep(2000);
		} catch (InterruptedException e) {
		}	
	
		System.err.print("Start dauny  ...");
		sFileName="d:\\programme\\dauny\\dauny.exe";
		nError=app.StartDauny(sFileName);
		if (nError==0)
			sMsg= "OK";
		else
			sMsg= "FAILED, error " + nError;		
		System.err.println(sMsg);	
		
		try {
			Thread.currentThread().sleep(3000);
		} catch (InterruptedException e) {
		}		
		
		System.err.print("Stop dauny  ...");
		sPathToDauny="d:\\programme\\dauny\\";
		nError=app.StopDauny(sPathToDauny);
		if (nError==0)
			sMsg= "OK";
		else
			sMsg= "FAILED, error " + nError;		
		System.err.println(sMsg);
		
		try {
			Thread.currentThread().sleep(2000);
		} catch (InterruptedException e) {
		}
	
		System.err.print("encrypting passwort  ...");
		sUncryptPassword="PASS1";
		sKey="A7D46E59C16DC72245F1F1C42F235CED0D53D68F";
		sEncryptPassword=app.EncryptPasswort(sUncryptPassword,sKey);
		if (sEncryptPassword!=null)
			sMsg= "OK\n encrypted password: " + sEncryptPassword;
		else
			sMsg= "FAILED, error " + nError;		
		System.err.println(sMsg);	



		System.err.print("Destroy trayicon thread (needed in java app - don't forget!) ...");
		nError=app.DestoryTrayIconThread();
		if (nError==1)
			sMsg= "OK";
		else
			sMsg= "FAILED, error " + nError;		
		System.err.println(sMsg);

						
	}
}